#include <cstdio>
#include <cassert>
#include <algorithm>

using namespace std;
typedef long long ll;

const int MAXN = 110000;

ll l[MAXN];
ll r[MAXN];
ll m;

ll process(ll val, int cnt) {
  ll lf = 0;
  ll rg = m;
  while (rg - lf > 1) {
    ll mid = (lf + rg) / 2;

    // f[val] <= mid
    ll cur = mid;
    for (int i = 0; i < cnt; i++) {
      if (cur >= l[i]) {
        if (cur >= r[i]) {
          cur -= (r[i] - l[i]) / 2 + 1;
        } else {
          cur -= (cur - l[i]) / 2 + 1;
        }
      }
    }

//    printf("%lld %lld %lld\n", mid, cur, val);
    
    if (cur < val) {
      lf = mid;
    } else {
      rg = mid;
    }
  }
  return rg;
}

int main() {
  int n;
  scanf("%d", &n);
  scanf("%lld", &m);

  for (int i = 0; i < n; i++) {
    scanf("%lld %lld", &l[i], &r[i]);
    printf("%lld %lld\n", process(l[i], i), process(r[i], i));
  }
}
