#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <ctime>
#include <cassert>
#include <queue>
#include <stack>
#include <bitset>
#define y1 y11
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define mt make_tuple
#define NAME ""

using namespace std;
	
typedef long double ld;

const ld PI = acos(-1.0);


const int MAXN = 1000 * 1000 + 2;

int rmq[4 * MAXN];

void create_rmq(int v, int l, int r)
{
	rmq[v] = (r - l + 1);
	if (l != r)
	{
		create_rmq(v * 2 + 1, l, (l + r) / 2);
		create_rmq(v * 2 + 2, (l + r) / 2 + 1, r);
	}
}


int gtid(int x)
{
	int cur = 0;
	int l = 1, r = MAXN;
	while (r != l)
	{
		int md = (l + r) / 2;
		rmq[cur]--;
		cur = (cur * 2 + 1);
		if (rmq[cur] < x)
		{
			l = md + 1;
			x -= rmq[cur++];
		}
		else r = md;
	}
	rmq[cur]--;
	return l;
}



int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	create_rmq(0, 1, MAXN);
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;	
		int ar, al;
		for (int i = r; i >= l; i -= 2)
		{
			int v = gtid(i);
			if (i == r) ar = v;
			if (i == l) al = v;
		}
		cout << al << " " << ar << "\n";
	}
	return 0;
}


