#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <ctime>
#include <cassert>
#include <queue>
#include <stack>
#include <bitset>
#define y1 y11
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define mt make_tuple
#define NAME ""

using namespace std;
	
typedef long double ld;

const ld PI = acos(-1.0);


struct node
{
	node *l;
	node *r;
	int x;
};

typedef node* pnode;

const int MAXN = 1000 * 1000 * 1000 + 2;

pnode fullnode(int sz)
{
	pnode ans = new node();
	ans->l = ans->r = NULL;
	ans->x = sz;
	return ans;
}


void push(pnode a)
{
	if (!(a->l))
	{
		a->l = fullnode((a->x + 1) / 2);
		a->r = fullnode(a->x / 2);
	}
}

pnode root;

int gtid(int x)
{
	pnode cur = root;
	int cl = 1, sz = MAXN;
	while (sz > 1)
	{
		if (cur->x == sz) push(cur);
		cur->x--;
		if (cur->l->x < x)
		{
			cl += (sz + 1) / 2;
			x -= cur->l->x;
			sz = sz / 2;
			cur = cur->r;
		}
		else
		{
			sz = (sz + 1) / 2;
			cur = cur->l;
		}
	}
	cur->x--;
	return cl;
}



int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	root = fullnode(MAXN);
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;	
		int ar, al;
		for (int i = r; i >= l; i -= 2)
		{
			int v = gtid(i);
			if (i == r) ar = v;
			if (i == l) al = v;
		}
		cout << al << " " << ar << "\n";
	}
	return 0;
}


