#include <cstdio>
#include <cassert>
#include <algorithm>

using namespace std;
typedef long long ll;

const int MAXN = 110000;

ll l[MAXN];
ll r[MAXN];

ll process(ll val, int cnt) {
  for (int i = cnt - 1; i >= 0; i--) {
    if (val < l[i]) continue;
    ll d = (r[i] - l[i]) / 2 + 1;
    val += min(d, val - l[i] + 1);
  }
  return val;
}

int main() {
  int n;
  scanf("%d", &n);
  ll m;
  scanf("%lld", &m);

  for (int i = 0; i < n; i++) {
    scanf("%lld %lld", &l[i], &r[i]);
    printf("%lld %lld\n", process(l[i], i), process(r[i], i));
  }
}
