#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <string>
#include <cstring>
#include <ctime>
#include <cassert>
#include <queue>
#include <stack>
#include <bitset>
#define y1 y11
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
#define mt make_tuple
#define NAME ""

using namespace std;
	
typedef long double ld;

const ld PI = acos(-1.0);


struct node
{
	node *l;
	node *r;
	int x;
	int msk;
	int sz;
	int cn;
};

typedef node* pnode;

const int MAXN = 1000 * 1000 * 1000 + 2;

pnode fullnode(int sz)
{
	pnode ans = new node();
	ans->l = ans->r = NULL;
	ans->x = ans->sz = sz;
	ans->cn = ans->msk = 0;
	return ans;
}

void go(pnode a, int tp)
{
	if (a->x == 0) return;
	if ((a->x == 1) && (tp == 0)) return;
	a->x = (a->x - tp + 1) / 2;
	a->msk += (int)tp << ((a->cn)++);
}

void push(pnode a)
{
	if (!(a->l))
	{
		a->l = fullnode((a->sz + 1) / 2);
		a->r = fullnode(a->sz / 2);
	}
	for (int i = 0; i < a->cn; i++)
	{
		int v1 = ((a->msk) >> i) & 1;
		int v2= ((a->l->x & 1) ^ v1);
		go(a->l, v1);
		go(a->r, v2);
	}
	a->msk = a->cn = 0;
}

pnode root;

int gtid(int x)
{
	pnode cur = root;
	int cl = 1;
	while (cur->sz > 1)
	{
		push(cur);
		if (cur->l->x < x)
		{
			cl += cur->l->sz;
			x -= cur->l->x;
			cur = cur->r;
		}
		else
		{
			cur = cur->l;
		}
	}
	return cl;
}

int lv, rv;
void modify(pnode p, int x)
{
	if (x > rv) return;
	if (x + p->x <= lv) return;
	if ((x >= lv) && (x + p->x <= rv + 1))
	{
		if ((x & 1) == (lv & 1))
		{
			go(p, 1);
		}
		else go(p, 0);
		return;
	}
	push(p);
	modify(p->r, x + p->l->x);
	modify(p->l, x);
	p->x = p->l->x + p->r->x;
}

int main()
{
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	root = fullnode(MAXN);
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	int m;
	cin >> m;
	for (int i = 0; i < n; i++)
	{
		int l, r;
		cin >> l >> r;	
		cout << gtid(l) << " " << gtid(r) << "\n";
		lv = l, rv = r;
		modify(root, 1);
	}
	return 0;
}


